#open "constants";;
#open "primitive";;
(* instruct.ml : jeu d'instructions de la machine abstraite *)


type zam_instruction =
    Kquote of struct_constant 
  | Kget_global of qualified_ident
  | Kset_global of qualified_ident
  | Kaccess of int
  | Kgrab
  | Kpush
  | Kpushmark
  | Klet
  | Kendlet of int
  | Kdummy of int
  | Kupdate of int
  | Kapply
  | Ktermapply
  | Kstartfun of string
  | Kreturn
  | Kclosure of int
  | Kmakeblock of constr_tag * int 
  | Kprim of primitive 
  | Kpushtrap of int
  | Kpoptrap
  | Klabel of int
  | Kbranch of int
  | Kbranchif of int
  | Kbranchifnot of int
  | Kstrictbranchif of int
  | Kstrictbranchifnot of int
  | Ktest of bool_test * int
  | Kswitch of int vect
;;

let Nolabel = (-1)
;;
